import java.applet.Applet;
import java.awt.*;
import java.io.*;
import java.net.URL;

public class Quiz extends Applet {

    int numQuestions;
    int correctAnswers[];
    CheckboxGroup cbgAnswers[];
    Checkbox cbCorrectAnswers[];
    Button bDo;
    Label score;
    String wellDone;

    public Quiz() {
        wellDone = "All Correct";
    }

    public void loadQuestions() {
        setLayout(new GridLayout(0, 1, 2, 2));
        String filename = getParameter("file");
        String s;
        if((s = getParameter("message")) != null)
            wellDone = s;
        System.out.println(filename);
        InputStream isQuestions = null;
        try {
            URL urlQuestions = new URL(getDocumentBase(), filename);
            isQuestions = urlQuestions.openStream();
            DataInputStream disQs = new DataInputStream(isQuestions);
            int i = 0;
            String input;
            for(input = disQs.readLine(); input.startsWith("#"); input = disQs.readLine())
                System.out.println(input);

            numQuestions = (new Integer(input)).intValue();
            System.out.println("Num questions = " + numQuestions);
            correctAnswers = new int[numQuestions];
            cbgAnswers = new CheckboxGroup[numQuestions];
            cbCorrectAnswers = new Checkbox[numQuestions];
            for(; i < numQuestions; i++) {
                System.out.println("Question " + (i + 1));
                input = disQs.readLine();
                StringBufferInputStream sbisQ = new StringBufferInputStream(input);
                StreamTokenizer stQuestions;
                for(stQuestions = new StreamTokenizer(sbisQ); stQuestions.ttype != -3 || !stQuestions.sval.equals("Q"); stQuestions.nextToken());
                while(stQuestions.nextToken() != -2) ;
                int numAnswers = (int)stQuestions.nval;
                while(stQuestions.nextToken() != -2) ;
                correctAnswers[i] = (int)stQuestions.nval - 1;
                input = disQs.readLine();
                add(new Label(input));
                cbgAnswers[i] = new CheckboxGroup();
                for(int j = 0; j < numAnswers; j++) {
                    input = disQs.readLine();
                    Checkbox cbAns = new Checkbox(input, cbgAnswers[i], false);
                    if(j == correctAnswers[i])
                        cbCorrectAnswers[i] = cbAns;
                    add(cbAns);
                }

            }

            add(bDo = new Button("Correction"));
            add(score = new Label("Appuyer sur le bouton", 1));
            Font scoreF = score.getFont();
            Font scoreNF = new Font(scoreF.getName(), 1, scoreF.getSize());
            score.setFont(scoreNF);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        try {
            if(isQuestions != null)
                isQuestions.close();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    public boolean action(Event e, Object what) {
        if(e.target.equals(bDo)) {
            int numRight = 0;
            for(int i = 0; i < numQuestions; i++) {
                if(cbgAnswers[i].getCurrent() == null) {
                    score.setText("Rpondez  toutes les questions");
                    return true;
                }
                if(cbCorrectAnswers[i].equals(cbgAnswers[i].getCurrent()))
                    numRight++;
            }

            if(numRight < numQuestions)
                score.setText("Score: " + numRight + " sur " + numQuestions);
            else
                score.setText(wellDone);
            return true;
        } else {
            return false;
        }
    }

    public void init() {
        loadQuestions();
    }
}
